/*
 * @file main2.c
 *
 * A program using an even further extended subset of the functionality
 * of the list module.
 */

#include <stdlib.h>
#include <stdio.h>

#include "list.h"

void
printdec(int num)
{
    printf(" %d", num);
}

void
sumup(int num, void *state)
{
    int *p = (int *) state;
    *p += num;
}

void
multup(int num, void *state)
{
    int *p = (int *) state;
    *p *= num;
}

int
main(int argc, char *argv[])
{
    struct list* my_list = NULL;
    int sum = 0, prod = 1;

    my_list = push_front(my_list, 34);
    my_list = push_front(my_list, 18);
    my_list = push_back(my_list, 56);

    printf("The sum of");
    foreach_list_simple(my_list, printdec);
    foreach_list(my_list, sumup, &sum);
    printf(" is %d.\n", sum);
    
    printf("The product of");
    foreach_list_simple(my_list, printdec);
    foreach_list(my_list, multup, &prod);
    printf(" is %d.\n", prod);
    
    dispose_list(my_list);
    return 0;
}
